include:
    - '/golemio-globals/service-versions.yml'
    - '/golemio/module-tests/base.yml'

# expected variables :
# CICD_NO_MIGRATIONS (bool)
# POSTGRES_MIGRATIONS_DIR_DEPENDENCIES (path/glob)

variables: 
    POSTGRES_HOST: postgres
    POSTGRES_USER: oict
    POSTGRES_PASSWORD: oict-pass
    POSTGRES_DB: oict-test
    SQL_DUMP_FILES: db/example/*.sql
    POSTGRES_MIGRATIONS_DIR: "db/migrations/**/postgresql"

.run-tests: &run-tests
    - export POSTGRES_CONN=postgres://$POSTGRES_USER:$POSTGRES_PASSWORD@$POSTGRES_HOST/$POSTGRES_DB
    - npm install --ignore-scripts --progress=false
    - |
        if [ $CICD_NO_MIGRATIONS ]; then
          echo -e "\033[1;37mNo migrations set.\033[0m"
        elif [ -n "${POSTGRES_MIGRATIONS_DIR_DEPENDENCIES}" ]; then
          npx golemio migrate-db up --postgres --silent --path "$POSTGRES_MIGRATIONS_DIR_DEPENDENCIES" --path "$POSTGRES_MIGRATIONS_DIR"
        else
          npx golemio migrate-db up --postgres --silent --path "$POSTGRES_MIGRATIONS_DIR"
        fi

run_tests:
    variables:
        RABBITMQ_MANAGEMENT_ALLOW_WEB_ACCESS: true
        RABBIT_CONN: amqp://user:bitnami@rabbitmq
        RABBIT_EXCHANGE_NAME: oict-test
    services:
        - name: bitnami/rabbitmq:3.12.12-debian-11-r6
          alias: rabbitmq
        - !reference [.postgis-image]
    before_script:
        - *run-tests

#run_tests-node-next:
#    variables:
#        RABBITMQ_MANAGEMENT_ALLOW_WEB_ACCESS: true
#        RABBIT_CONN: amqp://user:bitnami@rabbitmq
#        RABBIT_EXCHANGE_NAME: oict-test
#    services:
#        - name: bitnami/rabbitmq:3.12.12-debian-11-r6
#          alias: rabbitmq
#        - !reference [.postgis-next-image]
#    before_script:
#        - *run-tests
